SDL_RWops Struct Reference

`#include <SDL_rwops.h>`

## Data Fields

Sint64(* | size )(struct SDL_RWops *context)
Sint64(* | seek )(struct SDL_RWops *context, Sint64 offset, int whence)
size_t(* | read )(struct SDL_RWops *context, void *ptr, size_t size, size_t maxnum)
size_t(* | write )(struct SDL_RWops *context, const void *ptr, size_t size, size_t num)
int(* | close )(struct SDL_RWops *context)
Uint32 | type
union {
struct {
SDL_bool append
void * h
struct {
void * data
size_t size
size_t left
} buffer
} windowsio
struct {
SDL_bool autoclose
FILE * fp
} stdio
struct {
Uint8 * base
Uint8 * here
Uint8 * stop
} mem
struct {
void * data1
void * data2
} unknown
} | hidden

## Detailed Description

This is the read/write operation structure – very basic.

Definition at line 52 of file SDL_rwops.h.

## Field Documentation

SDL_bool SDL_RWops::append

Definition at line 112 of file SDL_rwops.h.

SDL_bool SDL_RWops::autoclose

Definition at line 126 of file SDL_rwops.h.

Uint8* SDL_RWops::base

Definition at line 132 of file SDL_rwops.h.

struct { ... } SDL_RWops::buffer

int( * SDL_RWops::close) (struct SDL_RWops *context)

Close and free an allocated SDL_RWops structure.

Returns
  0 if successful or -1 on write error when flushing data.

Definition at line 91 of file SDL_rwops.h.

Referenced by main(), rwops_error_quit(), SDL_RWFromConstMem(), SDL_RWFromFile(), and SDL_RWFromMem().

void* SDL_RWops::data

Definition at line 116 of file SDL_rwops.h.

void* SDL_RWops::data1

Definition at line 138 of file SDL_rwops.h.

void* SDL_RWops::data2

Definition at line 139 of file SDL_rwops.h.

FILE* SDL_RWops::fp

Definition at line 127 of file SDL_rwops.h.

void* SDL_RWops::h

Definition at line 113 of file SDL_rwops.h.

Uint8* SDL_RWops::here

Definition at line 133 of file SDL_rwops.h.

union { ... } SDL_RWops::hidden

Referenced by mem_read(), mem_seek(), mem_size(), mem_write(), SDL_RWFromConstMem(), SDL_RWFromFile(), and SDL_RWFromMem().

size_t SDL_RWops::left

Definition at line 118 of file SDL_rwops.h.

struct { ... } SDL_RWops::mem

Referenced by mem_read(), mem_seek(), mem_size(), mem_write(), SDL_RWFromConstMem(), and SDL_RWFromMem().

size_t( * SDL_RWops::read) (struct SDL_RWops *context, void *ptr, size_t size, size_t maxnum)

Read up to `maxnum` objects each of size `size` from the data stream to the area pointed at by `ptr`.

Returns
  the number of objects read, or 0 at error or end of file.

Definition at line 74 of file SDL_rwops.h.

Referenced by main(), SDL_RWFromConstMem(), SDL_RWFromFile(), and SDL_RWFromMem().

Sint64( * SDL_RWops::seek) (struct SDL_RWops *context, Sint64 offset, int whence)

Seek to `offset` relative to `whence`, one of stdio's whence values: RW_SEEK_SET, RW_SEEK_CUR, RW_SEEK_END

Returns
  the final offset in the data stream, or -1 on error.

Definition at line 65 of file SDL_rwops.h.

Referenced by main(), SDL_RWFromConstMem(), SDL_RWFromFile(), and SDL_RWFromMem().

Sint64( * SDL_RWops::size) (struct SDL_RWops *context)

Return the size of the file in this rwops, or -1 if unknown

Definition at line 57 of file SDL_rwops.h.

Referenced by SDL_RWFromConstMem(), SDL_RWFromFile(), and SDL_RWFromMem().

size_t SDL_RWops::size

Definition at line 117 of file SDL_rwops.h.

struct { ... } SDL_RWops::stdio

Referenced by SDL_RWFromFile().

Uint8* SDL_RWops::stop

Definition at line 134 of file SDL_rwops.h.

Uint32 SDL_RWops::type

Definition at line 93 of file SDL_rwops.h.

Referenced by rwops_testAllocFree(), rwops_testConstMem(), rwops_testFileRead(), rwops_testFileWrite(), rwops_testFPRead(), rwops_testFPWrite(), SDL_AllocRW(), SDL_RWFromConstMem(), SDL_RWFromFile(), and SDL_RWFromMem().

struct { ... } SDL_RWops::unknown

struct { ... } SDL_RWops::windowsio

size_t( * SDL_RWops::write) (struct SDL_RWops *context, const void *ptr, size_t size, size_t num)

Write exactly `num` objects each of size `size` from the area pointed at by `ptr` to data stream.

Returns
  the number of objects written, or 0 at error or end of file.

Definition at line 83 of file SDL_rwops.h.

Referenced by main(), SDL_RWFromConstMem(), SDL_RWFromFile(), and SDL_RWFromMem().

The documentation for this struct was generated from the following file:

- include/SDL_rwops.h